>From 4b4be27864f683a9b3464b86d6cfa567f8ab6bd2 Mon Sep 17 00:00:00 2001
From: Jesper Krogh <jk@novozymes.com>
Date: Thu, 17 Feb 2011 22:21:52 +0100
Subject: [PATCH] Take null_frac into account in calculating selectivity for @@ operator. This makes behaviour align with what > operator does for integers.

---
 src/backend/tsearch/ts_selfuncs.c |    4 ++--
 1 files changed, 2 insertions(+), 2 deletions(-)

diff --git a/src/backend/tsearch/ts_selfuncs.c b/src/backend/tsearch/ts_selfuncs.c
index 8ce9fb4..a4f3219 100644
--- a/src/backend/tsearch/ts_selfuncs.c
+++ b/src/backend/tsearch/ts_selfuncs.c
@@ -180,14 +180,14 @@ tsquerysel(VariableStatData *vardata, Datum constval)
 			 * There is a most-common-elements slot for the tsvector Var, so
 			 * use that.
 			 */
-			selec = mcelem_tsquery_selec(query, values, nvalues,
+			selec = (1.0 - stats->stanullfrac ) * mcelem_tsquery_selec(query, values, nvalues,
 										 numbers, nnumbers);
 			free_attstatsslot(TEXTOID, values, nvalues, numbers, nnumbers);
 		}
 		else
 		{
 			/* No most-common-elements info, so do without */
-			selec = tsquery_opr_selec_no_stats(query);
+			selec = (1.0 - stats->stanullfrac ) * tsquery_opr_selec_no_stats(query);
 		}
 	}
 	else
-- 
1.7.0.4

